// %flair:license{
// This file is part of the Flair framework distributed under the
// CECILL-C License, Version 1.0.
// %flair:license}
#ifndef USSENSORPLOT_H_INCLUDED
#define USSENSORPLOT_H_INCLUDED

#include "DataRemote.h"
#include <stdint.h>
#include <QPen>

class Layout;
class QwtPlot;
class QwtPlotCurve;
class QwtPlotItem;
class QMouseEvent;
class QwtPlotMarker;

class UsSensorPlot : public DataRemote {
  Q_OBJECT

public:
  UsSensorPlot(Layout *parent, int row, int col, QString plot_name,
             QString y_name, float ymin,float ymax, uint32_t nbSamples,QString datasType,bool enabled, int period);
  ~UsSensorPlot();

protected:
  void mousePressEvent(QMouseEvent *event);

private:
  QwtPlot *plot;
  void XmlEvent(QDomElement dom);
  void alignScales(void);
  float xmin_orig, xmax_orig, ymin_orig, ymax_orig;

  QwtPlotCurve *datas;
  QwtPlotMarker *firstPeakStart,*firstPeakEnd,*secondPeakStart,*secondPeakEnd;
  QString datasType;
  bool datas_first_update;
  double *dx;
  double *dy;
  uint32_t nbSamples;

  bool eventFilter(QObject *, QEvent *);
  void setYAxisScale(float ymin, float ymax);
  void setXAxisScale(float xmin, float xmax);
  void BufEvent(char **buf, int *buf_size, uint16_t period, bool big_endian);
};

#endif // USSENSORPLOT_H_INCLUDED
